<template>
  <div class="app-container">
    <el-row :gutter="20" style="min-height: calc(100vh - 143px);">
      <!--用户数据-->
      <el-col :span="24" :xs="24" class="pageSediment" style="min-height: calc(100vh - 143px);">
        <el-form
          ref="queryForm"
          :inline="true"
          :model="queryParams"
          label-width="68px"
        >
          <el-form-item label="用户名称" prop="nickName">
            <el-input
              v-model="queryParams.nickName"
              clearable
              placeholder="请输入用户名称称"
              size="small"
              style="width: 240px"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="用户工号" prop="userName">
            <el-input
              v-model="queryParams.userName"
              clearable
              placeholder="请输入用户工号"
              size="small"
              style="width: 240px"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="状态" prop="status">
            <el-select
              v-model="queryParams.status"
              clearable
              placeholder="用户状态"
              size="small"
              style="width: 240px"
            >
              <el-option
                v-for="dict in statusOptions"
                :key="dict.dictValue"
                :label="dict.dictLabel"
                :value="dict.dictValue"
              />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button
              icon="el-icon-search"
              size="mini"
              type="primary"
              @click="handleQuery"
            >搜索
            </el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置
            </el-button>
            <el-button
              v-hasPermi="['system:user:add']"
              icon="el-icon-plus"
              size="mini"
              type="primary"
              @click="handleAdd"
            >新增
            </el-button>
            <el-button
              v-hasPermi="['system:user:edit']"
              :disabled="single"
              icon="el-icon-edit"
              size="mini"
              type="success"
              @click="handleUpdate"
            >修改
            </el-button>
            <el-button
              v-hasPermi="['system:user:resetPwd']"
              :disabled="single"
              icon="el-icon-key"
              size="mini"
              type="success"
              @click="handleResetPwd"
            >重置密码
            </el-button>
            <el-button
              v-hasPermi="['system:user:remove']"
              :disabled="multiple"
              icon="el-icon-delete"
              size="mini"
              type="danger"
              @click="handleDelete"
            >删除
            </el-button>
            <el-button
              v-hasPermi="['system:user:export']"
              icon="el-icon-download"
              size="mini"
              type="warning"
              @click="handleExport"
            >导出
            </el-button>
          </el-form-item>
        </el-form>

        <el-table
          ref="multipleTable"
          v-loading="loading"
          :data="userList"  border
          stripe tooltip-effect="light"
          @selection-change="handleSelectionChange"
          @row-click="handleRowClick"
        >
          <el-table-column align="center" type="selection" width="50"/>
          <el-table-column align="left" fixed="left" label="用户名称" min-width="100" prop="nickName"
                           show-overflow-tooltip
          />
          <el-table-column align="left" fixed="left" label="用户工号" min-width="200" prop="userName"
                           show-overflow-tooltip
          />
          <el-table-column
            align="left"
            label="所属科室"
            min-width="230"
            prop="deptName" show-overflow-tooltip
          />
          <!--          <el-table-column
                      align="center"
                      label="所属病区"
                      prop="wardName"
                    />-->
          <el-table-column
            align="left"
            label="手机号码"
            min-width="130"
            prop="phonenumber"
          />
          <el-table-column align="center" label="状态" width="90">
            <template slot-scope="scope">
              <el-switch
                v-model="scope.row.status"
                active-value="1"
                inactive-value="0"
                @change="handleStatusChange(scope.row)"
              ></el-switch>
            </template>
          </el-table-column>
          <!--          <el-table-column
                      align="center"
                      class-name="small-padding fixed-width"
                      label="操作"
                      width="180"
                    >
                      <template slot-scope="scope">
                        <el-button
                          v-hasPermi="['system:user:edit']"
                          icon="el-icon-edit"
                          size="mini"
                          type="text"
                          @click="handleUpdate(scope.row)"
                        >修改
                        </el-button
                        >
                        <el-button
                          v-if="scope.row.userId !== 1"
                          v-hasPermi="['system:user:remove']"
                          icon="el-icon-delete"
                          size="mini"
                          type="text"
                          @click="handleDelete(scope.row)"
                        >删除
                        </el-button
                        >
                        <el-button
                          v-hasPermi="['system:user:resetPwd']"
                          icon="el-icon-key"
                          size="mini"
                          type="text"
                          @click="handleResetPwd(scope.row)"
                        >重置
                        </el-button
                        >
                      </template>
                    </el-table-column>-->
        </el-table>

        <pagination
          v-show="total > 0"
          :limit.sync="queryParams.pageSize"
          :page.sync="queryParams.pageNum"
          :total="total"
          @pagination="getList"
        />
      </el-col>
    </el-row>

    <!-- 添加或修改参数配置对话框 -->
    <el-dialog
      v-dialogDrag
      :close-on-click-modal="false"
      :title="title"
      :visible.sync="open"
      width="600px"
    >
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="用户姓名" prop="nickName">
              <el-input v-model="form.nickName" placeholder="请输入用户姓名"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="手机号码" prop="phonenumber">
              <el-input
                v-model="form.phonenumber"
                maxlength="11"
                placeholder="请输入手机号码"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="邮箱" prop="email">
              <el-input
                v-model="form.email"
                maxlength="50"
                placeholder="请输入邮箱"
              />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="用户工号" prop="userName">
              <el-input v-model="form.userName" placeholder="请输入用户工号"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="病区" prop="wardId">
              <el-select
                v-model="form.wardId"
                clearable
                placeholder=""
                size="small"
              >
                <el-option
                  v-for="dict in wardList"
                  :key="dict.deptId"
                  :label="dict.deptName"
                  :value="dict.deptId"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item
              v-if="form.userId == undefined"
              label="用户密码"
              prop="password"
            >
              <el-input
                v-model="form.password"
                placeholder="请输入用户密码"
                type="password"
              />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="用户性别">
              <el-select v-model="form.sex" placeholder="请选择">
                <el-option
                  v-for="dict in sexOptions"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="状态">
              <el-radio-group v-model="form.status">
                <el-radio
                  v-for="dict in statusOptions"
                  :key="dict.dictValue"
                  :label="dict.dictValue"
                >{{ dict.dictLabel }}
                </el-radio
                >
              </el-radio-group>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="角色">
              <el-select v-model="form.roleIds" multiple placeholder="请选择">
                <el-option
                  v-for="item in roleOptions"
                  :key="item.roleId"
                  :disabled="item.status == 0"
                  :label="item.roleName"
                  :value="item.roleId"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="所属科室" prop="defaultDeptCode">
              <el-select
                v-model="form.deptId"
                clearable
                filterable
                placeholder="请选择科室"
                @change="formDeptChange"
              >
                <el-option
                  v-for="item in deptOptions2"
                  :key="item.deptId"
                  :label="`${item.deptName} [${item.deptId}]`"
                  :value="item.deptId"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item label="备注">
              <el-input
                v-model="form.remark"
                placeholder="请输入内容"
                type="textarea"
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listUser,
  getUser,
  delUser,
  addUser,
  updateUser,
  exportUser,
  resetUserPwd,
  changeUserStatus,
  syncUserInfo
} from '@/api/system/user'
import { listDept } from '@/api/basis/dept'
import { treeselect } from '@/api/system/dept'
import { listPost } from '@/api/system/post'
import { listRole } from '@/api/system/role'
import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'

export default {
  name: 'User',
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 用户表格数据
      userList: null,
      // 弹出层标题
      title: '',
      // 部门树选项
      deptOptions: undefined,
      // 是否显示弹出层
      open: false,
      // 部门名称
      deptName: undefined,
      // 默认密码
      initPassword: undefined,
      // 日期范围
      dateRange: [],
      // 状态数据字典
      statusOptions: [],
      // 性别状态字典
      sexOptions: [],
      // 岗位选项
      postOptions: [],
      // 角色选项
      roleOptions: [],
      doctorIds: [],
      doctorId: undefined,
      formDocOptions: [],
      //科室选项数据
      deptOptions2: [],
      //医生选项数据
      docOptions: [],
      // 表单参数
      form: {},
      defaultProps: {
        children: 'children',
        label: 'label'
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        userName: undefined,
        nickName: undefined,
        phonenumber: undefined,
        status: undefined,
        deptId: undefined,
        deptId2: undefined,
        doctorId: undefined
      },
      // 表单校验
      rules: {
        userName: [
          { required: true, message: '用户名称不能为空', trigger: 'blur' }
        ],
        nickName: [
          { required: true, message: '用户昵称不能为空', trigger: 'blur' }
        ],
        deptId: [
          { required: true, message: '归属部门不能为空', trigger: 'blur' }
        ],
        password: [
          { required: true, message: '用户密码不能为空', trigger: 'blur' }
        ],
        email: [
          {
            type: 'email',
            message: '\'请输入正确的邮箱地址',
            trigger: ['blur', 'change']
          }
        ],
        phonenumber: [
          {
            pattern: /^1[3|4|5|6|7|8|9][0-9]\d{8}$/,
            message: '请输入正确的手机号码',
            trigger: 'blur'
          }
        ]
      },
      wardList: [] // 病区列表
    }
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val)
    }
  },
  created() {
    this.loadingDeptOptions()
    this.loadingDocOptions()
  },
  methods: {
    /** 查询用户列表 */
    formDeptChange(val, empty) {

    },
    tableDocFormat(row) {
      let name = ''
      this.deptOptions2.forEach(item => {
        if (row.defaultDeptCode == item.deptId) {
          name = item.deptName
          return false
        }
      })
      return name
    },
    loadingDocOptions() {
      //this.docOptions = res.rows;

      this.getList()
      this.getTreeselect()
      this.getDicts('sys_normal_disable').then(response => {
        this.statusOptions = response.data
      })
      this.getDicts('sys_user_sex').then(response => {
        this.sexOptions = response.data
      })
      this.getConfigKey('sys.user.initPassword').then(response => {
        this.initPassword = response.data
      })

    },
    loadingDeptOptions() {
      listDept().then(response => {
        this.deptOptions2 = response.rows
      })
      listDept({ deptType: 4 }).then(response => {
        this.wardList = response.rows
      })
    },
    getList() {
      this.loading = true
      listUser(this.addDateRange(this.queryParams, this.dateRange)).then(
        response => {
          this.userList = response.rows
          this.total = response.total
          this.loading = false
        }
      )
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data
      })
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true
      return data.label.indexOf(value) !== -1
    },
    /** 查询角色列表 */
    getRoles() {
      listRole().then(response => {
        this.roleOptions = response.rows
      })
    },
    // 用户状态修改
    handleStatusChange(row) {
      let text = row.status === '1' ? '启用' : '停用'
      this.$confirm(
        '确认要"' + text + '""' + row.userName + '"用户吗?',
        '警告',
        {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }
      )
        .then(function() {
          return changeUserStatus(row.userId, row.status)
        })
        .then(() => {
          this.msgSuccess(text + '成功')
        })
        .catch(function() {
          row.status = row.status === '1' ? '0' : '1'
        })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        userId: undefined,
        deptId: 100,
        defaultDeptCode: undefined,
        userName: undefined,
        nickName: undefined,
        password: undefined,
        phonenumber: undefined,
        email: undefined,
        sex: undefined,
        status: '1',
        remark: undefined,
        postIds: [],
        roleIds: []
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.page = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.userId)
      this.single = selection.length != 1
      this.multiple = !selection.length
    },
    handleRowClick(	row, column, event){
      this.$refs.multipleTable.toggleRowSelection(row);
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.getTreeselect()
      this.getRoles()
      this.open = true
      this.title = '添加用户'
      this.form.password = this.initPassword
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      this.getTreeselect()
      this.getRoles()
      const userId = row.userId || this.ids
      getUser(userId).then(response => {
        this.form = response.data
        this.form.postIds = response.postIds
        this.form.roleIds = response.roleIds
        this.open = true
        this.title = '修改用户'
        this.form.password = ''
      })
    },
    /*同步 */
    handleSync() {
      this.$confirm(
        '确认同步用户信息?',
        '警告',
        {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }
      )
        .then(function() {
          return syncUserInfo()
        })
        .then(() => {
          this.getList()
          this.msgSuccess('同步成功')
        })
        .catch(function() {
        })

    },
    /** 重置密码按钮操作 */
    handleResetPwd() {
      if (this.ids.length === 1) {
        let row = this.userList.find(item => item.userId === this.ids[0])
        this.$prompt('请输入"' + row.userName + '"的新密码', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消'
        })
          .then(({ value }) => {
            resetUserPwd(row.userId, value).then(response => {
              if (response.code === 200) {
                this.msgSuccess('修改成功，新密码是：' + value)
              } else {
                this.msgError(response.msg)
              }
            })
          })
          .catch(() => {
          })
      }
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.userId != undefined) {
            updateUser(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess('修改成功')
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          } else {
            addUser(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess('新增成功')
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const userIds = row.userId || this.ids
      this.$confirm(
        '是否确认删除用户编号为"' + userIds + '"的数据项?',
        '警告',
        {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }
      )
        .then(function() {
          return delUser(userIds)
        })
        .then(() => {
          this.getList()
          this.msgSuccess('删除成功')
        })
        .catch(function() {
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams
      this.$confirm('是否确认导出所有用户数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(function() {
          return exportUser(queryParams)
        })
        .then(response => {
          this.download(response.msg)
        })
        .catch(function() {
        })
    }
  }
}
</script>
